madkit.action

## Enum AgentAction

- java.lang.Object
- - java.lang.Enum<AgentAction>
  - - madkit.action.AgentAction

- All Implemented Interfaces:
    Serializable, Comparable<AgentAction>

      public enum AgentAction
      extends Enum<AgentAction>

  Enum representing agent actions
  Since:
    MaDKit 5.0.0.14
  Version:
    0.9
  Author:
    Fabien Michel

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BROADCAST_MESSAGE`
    `CREATE_GROUP`
    `KILL_AGENT`
    `LAUNCH_AGENT`
    `LEAVE_GROUP`
    `LEAVE_ROLE`
    `RELOAD`
    `REQUEST_ROLE`
    `SEND_MESSAGE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Action` | `getActionFor(AbstractAgent agent, Object... parameters)` Builds an action that will make the agent do the corresponding behavior
    `ActionInfo` | `getActionInfo()`
    `static AgentAction` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static AgentAction[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### LAUNCH_AGENT

          public static final AgentAction LAUNCH_AGENT

    - #### RELOAD

          public static final AgentAction RELOAD

    - #### CREATE_GROUP

          public static final AgentAction CREATE_GROUP

    - #### REQUEST_ROLE

          public static final AgentAction REQUEST_ROLE

    - #### LEAVE_ROLE

          public static final AgentAction LEAVE_ROLE

    - #### LEAVE_GROUP

          public static final AgentAction LEAVE_GROUP

    - #### SEND_MESSAGE

          public static final AgentAction SEND_MESSAGE

    - #### BROADCAST_MESSAGE

          public static final AgentAction BROADCAST_MESSAGE

    - #### KILL_AGENT

          public static final AgentAction KILL_AGENT

  - ### Method Detail

    - #### values

          public static AgentAction[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AgentAction c : AgentAction.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AgentAction valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getActionInfo

          public ActionInfo getActionInfo()

      Returns:
        the actionInfo corresponding to this constant

    - #### getActionFor

          public Action getActionFor(AbstractAgent agent,
                            Object... parameters)

      Builds an action that will make the agent do the corresponding behavior
      Parameters:
        `agent` - the agent on which this action will operate
        `parameters` - the info to be used
      Returns:
        the action corresponding to the enum

Fabien Michel, Olivier Gutknecht, Jacques Ferber - April 30 2015